<script setup lang="ts">
import PanelViewContents from '@/components/Panels/PanelViewContents.vue';
import SdgUserImage from '../SdgUserImage.vue';
import CardFlipper from '@/components/CardFlipper.vue';
import { ref } from 'vue';
import type { Person } from '@/types/Person';
import randomizedList from '@/libs/randomizedList';
import { reactive } from 'vue';
import type { Answers } from '@/types/Answers';
import AnswerSlotContentMultipleChoice from '@/components/AnswerSlotContentMultipleChoice.vue';

type AnswerType = {
  person: Person;
  type: 'image' | 'name' | string;
  sequence: number;
  id: number;
  flipped: boolean;
  locked: boolean;
  showing: 'front' | 'back';
};
const props = defineProps<{
  answers: Person[];
  showPlusOne: boolean;
  completed: boolean;
}>();

const colors = ['bg-red-500', 'bg-green-500', 'bg-yellow-500', 'bg-pink-500', 'bg-purple-500', 'bg-indigo-500', 'bg-gray-500', 'bg-red-500', 'bg-blue-500', 'bg-green-500', 'bg-yellow-500', 'bg-pink-500', 'bg-purple-500', 'bg-indigo-500', 'bg-gray-500'];

const emit = defineEmits(['onCorrectAnswerClick', 'onNextClick']);

let answers = reactive(
  randomizedList<AnswerType>(
    props.answers
      .reduce((accum, answer, index) => {
        accum.push({ person: answer, type: 'image', sequence: index, flipped: false, locked: false, id: 0, showing: 'front' });
        accum.push({ person: answer, type: 'name', sequence: index, flipped: false, locked: false, id: 0, showing: 'front' });
        return accum;
      }, [] as AnswerType[])
      .map((answer, index) => ({ ...answer, flipped: false, locked: false, id: index }))
  )
);
if (props.completed) {
  answers = answers.map((answer) => ({ ...answer, flipped: true, locked: true }));
}

const canClick = ref(true);

const onClickCard = (id: number) => {
  if (!canClick.value) {
    return;
  }

  const clickedCard = answers.find((answer) => answer.id === id);
  if (!clickedCard || clickedCard.locked || clickedCard.flipped) {
    return;
  }

  clickedCard.flipped = true;
  const flippedCards = answers.filter((answer) => !answer.locked).filter((answer) => answer.flipped);
  if (flippedCards.length !== 2) {
    return;
  }

  // did user click two matching cards
  if (flippedCards[0].person.id === flippedCards[1].person.id) {
    flippedCards.forEach((card) => {
      card.locked = true;
    });
    canClick.value = true;

    if (answers.every((answer) => answer.locked)) {
      onAnswerClick();
    }
    return;
  }

  // did user click two non-matching cards

  canClick.value = false;
  setTimeout(() => {
    flippedCards[0].flipped = false;
    flippedCards[1].flipped = false;
    canClick.value = true;
  }, 1000);
};

const onAnswerClick = () => {
  emit('onCorrectAnswerClick');
};

const next: Answers = {
  pickedCorrectAnswer: true,
  pickedIncorrectAnswer: false,
  answers: []
  //   {
  //     buttonText: 'Next',
  //     isCorrectAnswer: true,
  //     hasBeenPicked: false
  //   }
  // ]
};

const onNext = () => {
  emit('onNextClick');
};
</script>

<template>
  <PanelViewContents>
    <template #title> The Memory Game</template>

    <template #data>
      <div class="@container">
        <div class="grid @sm:grid-cols-2 @3xl:grid-cols-4 gap-2">
          <div v-for="answer in answers" :key="answer.id" class="flex flex-col items-center">
            <CardFlipper :id="answer.id" :canClick="canClick" :flipped="answer.flipped" class="w-50 h-50 rounded-xl shadow-md backface-hidden" @onFlipCard="onClickCard">
              <template #front>
                <div class="card-front bg-sdg-blue text-white text-6xl" :class="{ 'hover:cursor-pointer': !answer.locked }">
                  <h2>sdg</h2>
                </div>
              </template>
              <template #back>
                <div class="card-back" :class="{ 'bg-sdg-blue': !answer.locked, [colors[answer.sequence]]: answer.locked, 'border-2': answer.locked, 'border-black': answer.locked }">
                  <SdgUserImage v-if="answer.type === 'image'" :width="150" :person="answer.person" preventClick />
                  <div v-else>
                    <h2>{{ answer.person.displayName }}</h2>
                  </div>
                </div>
              </template>
            </CardFlipper>
          </div>
        </div>
      </div>
    </template>

    <template #answer>
      <div v-if="completed" class="text-center text-sdg-blue text-5xl pt-4">+1 point for that!</div>
      <AnswerSlotContentMultipleChoice class="p-8" :answers="next" :completed="completed" @onNext="onNext"> </AnswerSlotContentMultipleChoice>
    </template>
  </PanelViewContents>
</template>

<style scoped>
.card-front,
.card-back {
  position: absolute;
  width: 100%;
  height: 100%;
  backface-visibility: hidden;
  display: flex;
  align-items: center;
  justify-content: center;
  border-radius: 20px;
}

.card-back {
  color: #fff;
  transform: rotateY(180deg);
}
</style>
